-- functionsCtr.lua
-- Written By Habna


function ImportCtr( value )
	if value == "MI" then --Money Infos
		import (AppCtrD.."MoneyInfos");
		PlayerAtt = Player:GetAttributes();
		TB["win"].moneyChangedHandler = AddCallback(PlayerAtt, "MoneyChanged", function(sender, args) UpdateMoney(); end);
		UpdateMoney();
		MI["Ctr"]:SetPosition( _G.MILocX, 0 );
	elseif value == "DP" then --Destiny Points
		import (AppCtrD.."DestinyPoints");
		PlayerAtt = Player:GetAttributes();
		TB["win"].dpChangedHandler = AddCallback(PlayerAtt, "DestinyPointsChanged", function(sender, args) UpdateDestinyPoints(); end);
		UpdateDestinyPoints();
		DP["Ctr"]:SetPosition( _G.DPLocX, 0 );
	elseif value == "SP" then --Shards
		import (AppCtrD.."Shards");
		LoadPlayerWallet();
		--PlayerShard = PlayerCurrency["Shard"];
		--TB["win"].spChangedHandler = AddCallback(PlayerShard, "QuantityChanged", function(sender, args) UpdateShards(); end);
		UpdateShards();
		SP["Ctr"]:SetPosition( _G.SPLocX, 0 );
	elseif value == "SM" then --Skirmish Marks
		import (AppCtrD.."SkirmishMarks");
		LoadPlayerWallet();
		--PlayerMark = PlayerCurrency["Mark"];
		--TB["win"].smChangedHandler = AddCallback(PlayerMark, "QuantityChanged", function(sender, args) UpdateMarks(); end);
		UpdateMarks();
		SM["Ctr"]:SetPosition( _G.SMLocX, 0 );
	elseif value == "MP" then --Medallions
		import (AppCtrD.."Medallions");
		LoadPlayerWallet();
		--PlayerShard = PlayerCurrency["Medallion"];
		--TB["win"].spChangedHandler = AddCallback(PlayerShard, "QuantityChanged", function(sender, args) UpdateMedallions(); end);
		UpdateMedallions();
		MP["Ctr"]:SetPosition( _G.MPLocX, 0 );
	elseif value == "SL" then --Seals
		import (AppCtrD.."Seals");
		LoadPlayerWallet();
		--PlayerSeals = PlayerCurrency["Seals"];
		--TB["win"].slChangedHandler = AddCallback(PlayerSeals, "QuantityChanged", function(sender, args) UpdateSeals(); end);
		UpdateSeals();
		SL["Ctr"]:SetPosition( _G.SLLocX, 0 );
	elseif value == "CP" then --Commodations
		import (AppCtrD.."Commodations");
		LoadPlayerWallet();
		--PlayerCommodation = PlayerCurrency["Commodation"];
		--TB["win"].cpChangedHandler = AddCallback(PlayerCommodation, "QuantityChanged", function(sender, args) UpdateCommodations(); end);
		UpdateCommodations();
		CP["Ctr"]:SetPosition( _G.CPLocX, 0 );
	elseif value == "BI" then --Backpack Infos
		import (AppCtrD.."BagInfos");
		Backpack = Player:GetBackpack();
		TB["win"].iaHandler = AddCallback(Backpack, "ItemAdded", function(sender, args) UpdateBackpackInfos(); end);
		TB["win"].irHandler = AddCallback(Backpack, "ItemRemoved", function(sender, args) ItemRemovedTimer:SetWantsUpdates( true ); end); --Workaround
		--TB["win"].irHandler = AddCallback(Backpack, "ItemRemoved", function(sender, args) UpdateBackpackInfos(); end);
		UpdateBackpackInfos();
		BI["Ctr"]:SetPosition( _G.BILocX, 0 );
	elseif value == "PI" then --Player Infos
		import (AppCtrD.."PlayerInfos");
		TB["win"].levelChangedHandler = AddCallback(Player, "LevelChanged", function(sender, args) PI["Lvl"]:SetText( Player:GetLevel() ); end);
		TB["win"].nameChangedHandler = AddCallback(Player, "NameChanged", function(sender, args) PI["Name"]:SetText( Player:GetName() ); end);
		UpdatePlayersInfos();
		PI["Ctr"]:SetPosition( _G.PILocX, 0 );
	elseif value == "DI" then --Durability Infos
		import (AppCtrD.."DurabilityInfos");
		UpdateDurabilityInfos();
		DI["Ctr"]:SetPosition( _G.DILocX, 0 );
	elseif value == "EI" then --Equipment Infos
		import (AppCtrD.."EquipInfos");
		TB["win"].ieHandler = AddCallback(PlayerEquipment, "ItemEquipped", function(sender, args) UpdateEquipsInfos(); end);
		TB["win"].iueHandler = AddCallback(PlayerEquipment, "ItemUnequipped", function(sender, args) ItemUnEquippedTimer:SetWantsUpdates( true ); end); --Workaround
		--TB["win"].iueHandler = AddCallback(PlayerEquipment, "ItemUnequipped", function(sender, args) UpdateEquipsInfos(); end);
		UpdateEquipsInfos();
		EI["Ctr"]:SetPosition( _G.EILocX, 0 );
	elseif value == "PL" then --Player Location
		import (AppCtrD.."PlayerLoc");
		TB["win"].ChatReceivedHandler = AddCallback(
		Turbine.Chat, "Received", function(sender, args)
			sMess = args.Message;

			----                1111111111222222222233333333 
			----       1234567890123456789012345678901234567
			--sMess = "Entered the Bree-town - Trade channel";

			if sMess ~= nil then
				if GLocale == "en" then sE, sC, iE = "Entered", "-%s", 13;
				elseif GLocale == "fr" then sE, sC, iE = "Canal", "-%s", 7;
				elseif GLocale == "de" then sE, sC, iE = "Kanal", "-%s", 13; end

				local bFound = string.find(sMess, sE, 1);
				if bFound ~= nil then
					local iLoc = string.find(sMess, sC, 1);
					if iLoc ~= nil then
						-- Extract Location from args.Message
						local PLoc = string.sub( sMess, iE, iLoc - 1 );
						UpdatePlayerLoc(PLoc);
						--ReplaceModuleLocation( "right" );
					end
				end
			end
		end);

		PLoc = L["PLMsg"];
		UpdatePlayerLoc(PLoc);
		PL["Ctr"]:SetPosition( _G.PLLocX, 0 );
	elseif value == "GT" then --Game Time
		import (AppCtrD.."GameTime");
		--PlayerTime = Turbine.Engine.GetDate();
		--TB["win"].gtmChangedHandler = AddCallback(PlayerTime, "MinuteChanged", function(sender, args) UpdateGameTime(); end);
		UpdateGameTime();
		GT["Ctr"]:SetPosition( _G.GTLocX, 0 );
	end
end

function GetEquipmentInfos()
	LoadEquipmentTable();

	PlayerEquipment = Player:GetEquipment();
	if PlayerEquipment == nil then return end --Remove when Player Equipment info are available before plugin is loaded

	itemEquipHandler = {};
	itemEquip = {};
	itemsTotDurability, itemTotScore, numItems = 0, 0, 0;
	
	for i = 1, 20 do
		local PlayerEquipItem = PlayerEquipment:GetItem( EquipSlots[Slots[i]] );
		itemEquip[i] = Turbine.UI.Lotro.ItemControl( PlayerEquipItem );

		-- Item Name, WearState, Quality & Durability
		if PlayerEquipItem ~= nil then
			itemEquip[i].Name = PlayerEquipItem:GetName();
			itemEquip[i].Quality = PlayerEquipItem:GetQuality();
			itemEquip[i].Durability = PlayerEquipItem:GetDurability();
			itemEquip[i].Item = true;

			WearState = PlayerEquipItem:GetWearState();
			itemEquip[i].WearState = WearState
			if WearState ~= 0 then numItems = numItems + 1; end -- Undefined item must not be count (Pocket item are as Undefined Wear State, they are indestructible)

			if itemEquipHandler[i] == nil then itemEquipHandler[i] = AddCallback(PlayerEquipItem, "WearStateChanged", function(sender, args) ChangeWearState(i); end); end
			-- Unable to know witch item was removed/added at this time
			--if ItemEquippedHandler[i] == nil then ItemEquippedHandler[i] = AddCallback(PlayerEquipment, "ItemEquipped", function(sender, args) ChangeItem(i, "add"); end); end
			--if ItemUnequippedHandler[i] == nil then ItemUnequippedHandler[i] = AddCallback(PlayerEquipment, "ItemUnequipped", function(sender, args) ChangeItem(i, "remove"); end); end
		else
			itemEquip[i].Name = "zEmpty";
			itemEquip[i].WearState = 0;
			itemEquip[i].Quality = 0;
			itemEquip[i].Durability = 0;
			itemEquip[i].Item = false;
		end
	end
end

function CalculateAllItemsDurability()
	local itemDurability = 0;
	itemsTotDurability = 0;

	for i = 1, 20 do
		-- Item Wear State
		if itemEquip[i].WearState == 0 then itemDurability = 0; end -- undefined
		if itemEquip[i].WearState == 2 then itemDurability = 100; end -- Pristine / parfait
		if itemEquip[i].WearState == 4 then itemDurability = 75; end -- Worn / us
		if itemEquip[i].WearState == 1 then itemDurability = 50; end -- Damaged / endommag
		if itemEquip[i].WearState == 3 then itemDurability = 0; end -- Broken / cass

		itemEquip[i].ItemDurPts = itemDurability;
		itemsTotDurability = itemsTotDurability + itemDurability;
	end

	itemsTotDurability = itemsTotDurability / numItems;
end

function CalculateAllItemsScore()
	local itemScore = 0;
	itemTotScore = 0;

	for i = 1, 20 do
		-- Item Score from it's Quality & Durability
		if itemEquip[i].Quality == 5 then itemScore = 50; end -- Common
		if itemEquip[i].Quality == 4 then itemScore = 100; end -- Uncommon
		if itemEquip[i].Quality == 3 then itemScore = 150; end -- Incomparable
		if itemEquip[i].Quality == 2 then itemScore = 200; end -- Rare
		if itemEquip[i].Quality == 1 then itemScore = 250; end -- Legendary
		if itemEquip[i].Quality == 0 then itemScore = 0; end -- undefined
		
		if itemEquip[i].Durability == 0 then itemScore = itemScore + 0; end -- undefined
		if itemEquip[i].Durability == 7 then itemScore = itemScore + 5; end -- Weak / Faible
		if itemEquip[i].Durability == 1 then itemScore = itemScore + 10; end -- Substantial
		if itemEquip[i].Durability == 2 then itemScore = itemScore + 20; end -- Brittle / Fragile
		if itemEquip[i].Durability == 3 then itemScore = itemScore + 30; end -- Normal
		if itemEquip[i].Durability == 4 then itemScore = itemScore + 40; end -- Tought / Robuste
		if itemEquip[i].Durability == 5 then itemScore = itemScore + 50; end -- Flimsy / Fragile ??
		if itemEquip[i].Durability == 6 then itemScore = itemScore + 60; end -- Indestructible
		
		itemEquip[i].ItemPts = itemScore;
		itemTotScore = itemTotScore + itemScore;
	end
end

function LoadPlayerMoney()
	wallet = Turbine.PluginData.Load( Turbine.DataScope.Server, "TitanBarWallet" );
	if wallet == nil then wallet = {}; end
end

-- **v Save character wallet infos v**
function SaveCharacterMoney()
	local PN = Player:GetName();

	local G = string.format("%.0f", MI["GLbl"]:GetText());
	local S = string.format("%.0f", MI["SLbl"]:GetText());
	local C = string.format("%.0f", MI["CLbl"]:GetText());
	local strData = G .. "/" .. S .. "/" .. C;

	wallet[PN] = strData;

	--table.sort( wallet );

	vWallet, i  = {}, 1;
	GoldTot, SilverTot, CopperTot = 0, 0, 0;

	for k,v in pairs(wallet) do
		if k ~= "Total" then
			vWallet[i] = {};
			vWallet[i].Name = k;

			-- Find and extract amount
			local pos1 = string.find(v, "/", 0);
			local pos2 = string.find(v, "/", pos1 + 1);
			
			local Gold = string.sub(v, 1, pos1 - 1);
			GoldTot = GoldTot + Gold;
			vWallet[i].G = Gold;

			local Silver = string.sub(v, pos1 + 1, pos2 - 1);
			SilverTot = SilverTot + Silver;
			vWallet[i].S = Silver;

			local Copper = string.sub(v, pos2 + 1, string.len(v));
			CopperTot = CopperTot + Copper;
			vWallet[i].C = Copper;

			i = i + 1;
		end
	end
	--************************************************************************
	if (string.len(CopperTot)==3) then
		local CopperTotX = CopperTot;
		SilverTot = SilverTot + string.sub(CopperTotX,1,-3);
		CopperTot = string.sub(CopperTot,2,-1);
	end
		
	if (string.len(SilverTot)==4) then
		local SilverTotX = SilverTot;
		GoldTot = GoldTot + string.sub(SilverTotX,1,-4);
		SilverTot = string.sub(SilverTot,2,-1);
	end
	--************************************************************************
	wallet["Total"] = GoldTot .. "/" .. SilverTot .. "/" .. CopperTot;

	Turbine.PluginData.Save( Turbine.DataScope.Server, "TitanBarWallet", wallet );
end
-- **^

function LoadPlayerWallet()
	PlayerWallet = Player:GetWallet();
	PlayerWalletSize = PlayerWallet:GetSize();
	
	if PlayerWalletSize == 0 then return end --Remove when Wallet info are available before plugin is loaded
	
	for i = 1, PlayerWalletSize do
		local CurItem = PlayerWallet:GetItem(i);
		local CurName = PlayerWallet:GetItem(i):GetName();

		PlayerCurrency[CurName] = CurItem;
		if PlayerCurrencyHandler[CurName] == nil then PlayerCurrencyHandler[CurName] = AddCallback(PlayerCurrency[CurName], "QuantityChanged", function(sender, args) UpdateCurrency(CurName); end); end
	end
end

function UpdateCurrency(str)
	if str == "Shard" and ShowShards then UpdateShards(); end
	if str == "Mark" and ShowSkirmishMarks then UpdateMarks(); end
	if str == "Medallion" and ShowMedallions then UpdateMedallions(); end
	if str == "Seal" and ShowSeals then UpdateSeals(); end
	if str == "Commodation" and ShowCommodations then UpdateCommodations(); end
end

function GetCurrency(str)
	CurQuantity = 0;
	
	for k,v in pairs(PlayerCurrency) do
		if k == str then
			CurQuantity = PlayerCurrency[str]:GetQuantity();
			break
		end
	end
	
	return CurQuantity
end