-- settings.lua
-- Written by Habna


-- **v Load / update / set default settings v**
function LoadSettings()
	if GLocale == "de" then settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "TitanBarSettingsDE" ); end
	if GLocale == "en" then settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "TitanBarSettingsEN" ); end
	if GLocale == "fr" then settings = Turbine.PluginData.Load( Turbine.DataScope.Character, "TitanBarSettingsFR" ); end
	
	if GLocale == "en" then	tA, tR, tG, tB, tX = 0.3, 0.3, 0.3, 0.3, 0;
	else tA, tR, tG, tB,tX = "0,3", "0,3", "0,3", "0,3", "0"; end

	if settings == nil then	settings = {}; end
	
	if settings.TitanBar == nil then settings.TitanBar = {}; end
	if settings.TitanBar.A == nil then settings.TitanBar.A = string.format("%.3f", tA); end --Default Alpha color value
	if settings.TitanBar.R == nil then settings.TitanBar.R = string.format("%.3f", tR); end --Default Red color value
	if settings.TitanBar.G == nil then settings.TitanBar.G = string.format("%.3f", tG); end --Default Green color value
	if settings.TitanBar.B == nil then settings.TitanBar.B = string.format("%.3f", tB); end --Default Blue color value
	if settings.TitanBar.L == nil then settings.TitanBar.L = GLocale; end -- TitanBar Language
	bcAlpha = tonumber(settings.TitanBar.A);
	bcRed = tonumber(settings.TitanBar.R);
	bcGreen = tonumber(settings.TitanBar.G);
	bcBlue = tonumber(settings.TitanBar.B);
	TBLocale = settings.TitanBar.L;
	import (AppLocaleD..TBLocale);

	if settings.Money == nil then settings.Money = {}; end
	if settings.Money.V == nil then settings.Money.V = false; end
	if settings.Money.A == nil then settings.Money.A = string.format("%.3f", tA); end
	if settings.Money.R == nil then settings.Money.R = string.format("%.3f", tR); end
	if settings.Money.G == nil then settings.Money.G = string.format("%.3f", tG); end
	if settings.Money.B == nil then settings.Money.B = string.format("%.3f", tB); end
	if settings.Money.X == nil then settings.Money.X = string.format("%.0f", 400); end
	if settings.Money.S == nil then settings.Money.S = true; end --Show Total Money of all character on TitanBar Money control.
	ShowMoney = settings.Money.V;
	MIbcAlpha = tonumber(settings.Money.A);
	MIbcRed = tonumber(settings.Money.R);
	MIbcGreen = tonumber(settings.Money.G);
	MIbcBlue = tonumber(settings.Money.B);
	_G.MILocX = tonumber(settings.Money.X);
	_G.STM = settings.Money.S;

	if settings.DestinyPoints == nil then settings.DestinyPoints = {}; end
	if settings.DestinyPoints.V == nil then settings.DestinyPoints.V = false; end
	if settings.DestinyPoints.A == nil then settings.DestinyPoints.A = string.format("%.3f", tA); end
	if settings.DestinyPoints.R == nil then settings.DestinyPoints.R = string.format("%.3f", tR); end
	if settings.DestinyPoints.G == nil then settings.DestinyPoints.G = string.format("%.3f", tG); end
	if settings.DestinyPoints.B == nil then settings.DestinyPoints.B = string.format("%.3f", tB); end
	if settings.DestinyPoints.X == nil then settings.DestinyPoints.X = string.format("%.0f", tX); end
	ShowDestinyPoints = settings.DestinyPoints.V;
	DPbcAlpha = tonumber(settings.DestinyPoints.A);
	DPbcRed = tonumber(settings.DestinyPoints.R);
	DPbcGreen = tonumber(settings.DestinyPoints.G);
	DPbcBlue = tonumber(settings.DestinyPoints.B);
	_G.DPLocX = tonumber(settings.DestinyPoints.X);

	if settings.Shards == nil then settings.Shards = {}; end
	if settings.Shards.V == nil then settings.Shards.V = false; end
	if settings.Shards.A == nil then settings.Shards.A = string.format("%.3f", tA); end
	if settings.Shards.R == nil then settings.Shards.R = string.format("%.3f", tR); end
	if settings.Shards.G == nil then settings.Shards.G = string.format("%.3f", tG); end
	if settings.Shards.B == nil then settings.Shards.B = string.format("%.3f", tB); end
	if settings.Shards.X == nil then settings.Shards.X = string.format("%.0f", tX); end
	ShowShards = settings.Shards.V;
	SPbcAlpha = tonumber(settings.Shards.A);
	SPbcRed = tonumber(settings.Shards.R);
	SPbcGreen = tonumber(settings.Shards.G);
	SPbcBlue = tonumber(settings.Shards.B);
	_G.SPLocX = tonumber(settings.Shards.X);
	
	if settings.SkirmishMarks == nil then settings.SkirmishMarks = {}; end
	if settings.SkirmishMarks.V == nil then settings.SkirmishMarks.V = false; end
	if settings.SkirmishMarks.A == nil then settings.SkirmishMarks.A = string.format("%.3f", tA); end
	if settings.SkirmishMarks.R == nil then settings.SkirmishMarks.R = string.format("%.3f", tR); end
	if settings.SkirmishMarks.G == nil then settings.SkirmishMarks.G = string.format("%.3f", tG); end
	if settings.SkirmishMarks.B == nil then settings.SkirmishMarks.B = string.format("%.3f", tB); end
	if settings.SkirmishMarks.X == nil then settings.SkirmishMarks.X = string.format("%.0f", tX); end
	ShowSkirmishMarks = settings.SkirmishMarks.V;
	SMbcAlpha = tonumber(settings.SkirmishMarks.A);
	SMbcRed = tonumber(settings.SkirmishMarks.R);
	SMbcGreen = tonumber(settings.SkirmishMarks.G);
	SMbcBlue = tonumber(settings.SkirmishMarks.B);
	_G.SMLocX = tonumber(settings.SkirmishMarks.X);
	
	if settings.Medallions == nil then settings.Medallions = {}; end
	if settings.Medallions.V == nil then settings.Medallions.V = false; end
	if settings.Medallions.A == nil then settings.Medallions.A = string.format("%.3f", tA); end
	if settings.Medallions.R == nil then settings.Medallions.R = string.format("%.3f", tR); end
	if settings.Medallions.G == nil then settings.Medallions.G = string.format("%.3f", tG); end
	if settings.Medallions.B == nil then settings.Medallions.B = string.format("%.3f", tB); end
	if settings.Medallions.X == nil then settings.Medallions.X = string.format("%.0f", tX); end
	ShowMedallions = settings.Medallions.V;
	MPbcAlpha = tonumber(settings.Medallions.A);
	MPbcRed = tonumber(settings.Medallions.R);
	MPbcGreen = tonumber(settings.Medallions.G);
	MPbcBlue = tonumber(settings.Medallions.B);
	_G.MPLocX = tonumber(settings.Medallions.X);

	if settings.Seals == nil then settings.Seals = {}; end
	if settings.Seals.V == nil then settings.Seals.V = false; end
	if settings.Seals.A == nil then settings.Seals.A = string.format("%.3f", tA); end
	if settings.Seals.R == nil then settings.Seals.R = string.format("%.3f", tR); end
	if settings.Seals.G == nil then settings.Seals.G = string.format("%.3f", tG); end
	if settings.Seals.B == nil then settings.Seals.B = string.format("%.3f", tB); end
	if settings.Seals.X == nil then settings.Seals.X = string.format("%.0f", tX); end
	ShowSeals = settings.Seals.V;
	SLbcAlpha = tonumber(settings.Seals.A);
	SLbcRed = tonumber(settings.Seals.R);
	SLbcGreen = tonumber(settings.Seals.G);
	SLbcBlue = tonumber(settings.Seals.B);
	_G.SLLocX = tonumber(settings.Seals.X);

	if settings.Commodations == nil then settings.Commodations = {}; end
	if settings.Commodations.V == nil then settings.Commodations.V = false; end
	if settings.Commodations.A == nil then settings.Commodations.A = string.format("%.3f", tA); end
	if settings.Commodations.R == nil then settings.Commodations.R = string.format("%.3f", tR); end
	if settings.Commodations.G == nil then settings.Commodations.G = string.format("%.3f", tG); end
	if settings.Commodations.B == nil then settings.Commodations.B = string.format("%.3f", tB); end
	if settings.Commodations.X == nil then settings.Commodations.X = string.format("%.0f", tX); end
	ShowCommodations = settings.Commodations.V;
	CPbcAlpha = tonumber(settings.Commodations.A);
	CPbcRed = tonumber(settings.Commodations.R);
	CPbcGreen = tonumber(settings.Commodations.G);
	CPbcBlue = tonumber(settings.Commodations.B);
	_G.CPLocX = tonumber(settings.Commodations.X);
	
	if settings.BagInfos == nil then settings.BagInfos = {}; end
	if settings.BagInfos.V == nil then settings.BagInfos.V = true; end
	if settings.BagInfos.A == nil then settings.BagInfos.A = string.format("%.3f", tA); end
	if settings.BagInfos.R == nil then settings.BagInfos.R = string.format("%.3f", tR); end
	if settings.BagInfos.G == nil then settings.BagInfos.G = string.format("%.3f", tG); end
	if settings.BagInfos.B == nil then settings.BagInfos.B = string.format("%.3f", tB); end
	if settings.BagInfos.X == nil then	settings.BagInfos.X = string.format("%.0f", tX); end
	ShowBagInfos = settings.BagInfos.V;
	BIbcAlpha = tonumber(settings.BagInfos.A);
	BIbcRed = tonumber(settings.BagInfos.R);
	BIbcGreen = tonumber(settings.BagInfos.G);
	BIbcBlue = tonumber(settings.BagInfos.B);
	_G.BILocX = tonumber(settings.BagInfos.X);

	if settings.PlayerInfos == nil then settings.PlayerInfos = {}; end
	if settings.PlayerInfos.V == nil then settings.PlayerInfos.V = true; end
	if settings.PlayerInfos.A == nil then settings.PlayerInfos.A = string.format("%.3f", tA); end
	if settings.PlayerInfos.R == nil then settings.PlayerInfos.R = string.format("%.3f", tR); end
	if settings.PlayerInfos.G == nil then settings.PlayerInfos.G = string.format("%.3f", tG); end
	if settings.PlayerInfos.B == nil then settings.PlayerInfos.B = string.format("%.3f", tB); end
	if settings.PlayerInfos.X == nil then settings.PlayerInfos.X = string.format("%.0f", 206); end
	ShowPlayerInfos = settings.PlayerInfos.V;
	PIbcAlpha = tonumber(settings.PlayerInfos.A);
	PIbcRed = tonumber(settings.PlayerInfos.R);
	PIbcGreen = tonumber(settings.PlayerInfos.G);
	PIbcBlue = tonumber(settings.PlayerInfos.B);
	_G.PILocX = tonumber(settings.PlayerInfos.X);

	if settings.EquipInfos == nil then	settings.EquipInfos = {}; end
	if settings.EquipInfos.V == nil then	settings.EquipInfos.V = true; end
	if settings.EquipInfos.A == nil then	settings.EquipInfos.A = string.format("%.3f", tA); end
	if settings.EquipInfos.R == nil then	settings.EquipInfos.R = string.format("%.3f", tR); end
	if settings.EquipInfos.G == nil then	settings.EquipInfos.G = string.format("%.3f", tG); end
	if settings.EquipInfos.B == nil then	settings.EquipInfos.B = string.format("%.3f", tB); end
	if settings.EquipInfos.X == nil then	settings.EquipInfos.X = string.format("%.0f", 68); end
	ShowEquipInfos = settings.EquipInfos.V;
	EIbcAlpha = tonumber(settings.EquipInfos.A);
	EIbcRed = tonumber(settings.EquipInfos.R);
	EIbcGreen = tonumber(settings.EquipInfos.G);
	EIbcBlue = tonumber(settings.EquipInfos.B);
	_G.EILocX = tonumber(settings.EquipInfos.X);

	if settings.DurabilityInfos == nil then settings.DurabilityInfos = {}; end
	if settings.DurabilityInfos.V == nil then settings.DurabilityInfos.V = true; end
	if settings.DurabilityInfos.A == nil then settings.DurabilityInfos.A = string.format("%.3f", tA); end
	if settings.DurabilityInfos.R == nil then settings.DurabilityInfos.R = string.format("%.3f", tR); end
	if settings.DurabilityInfos.G == nil then settings.DurabilityInfos.G = string.format("%.3f", tG); end
	if settings.DurabilityInfos.B == nil then settings.DurabilityInfos.B = string.format("%.3f", tB); end
	if settings.DurabilityInfos.X == nil then settings.DurabilityInfos.X = string.format("%.0f", 138); end
	ShowDurabilityInfos = settings.DurabilityInfos.V;
	DIbcAlpha = tonumber(settings.DurabilityInfos.A);
	DIbcRed = tonumber(settings.DurabilityInfos.R);
	DIbcGreen = tonumber(settings.DurabilityInfos.G);
	DIbcBlue = tonumber(settings.DurabilityInfos.B);
	_G.DILocX = tonumber(settings.DurabilityInfos.X);

	if settings.PlayerLoc == nil then settings.PlayerLoc = {}; end
	if settings.PlayerLoc.V == nil then settings.PlayerLoc.V = true; end
	if settings.PlayerLoc.A == nil then settings.PlayerLoc.A = string.format("%.3f", tA); end
	if settings.PlayerLoc.R == nil then settings.PlayerLoc.R = string.format("%.3f", tR); end
	if settings.PlayerLoc.G == nil then settings.PlayerLoc.G = string.format("%.3f", tG); end
	if settings.PlayerLoc.B == nil then settings.PlayerLoc.B = string.format("%.3f", tB); end
	if settings.PlayerLoc.X == nil then settings.PlayerLoc.X = string.format("%.0f", screenWidth - 205); end
	ShowPlayerLoc = settings.PlayerLoc.V;
	PLbcAlpha = tonumber(settings.PlayerLoc.A);
	PLbcRed = tonumber(settings.PlayerLoc.R);
	PLbcGreen = tonumber(settings.PlayerLoc.G);
	PLbcBlue = tonumber(settings.PlayerLoc.B);
	_G.PLLocX = tonumber(settings.PlayerLoc.X);

	if settings.GameTime == nil then settings.GameTime = {}; end
	if settings.GameTime.V == nil then settings.GameTime.V = true; end
	if settings.GameTime.A == nil then settings.GameTime.A = string.format("%.3f", tA); end
	if settings.GameTime.R == nil then settings.GameTime.R = string.format("%.3f", tR); end
	if settings.GameTime.G == nil then settings.GameTime.G = string.format("%.3f", tG); end
	if settings.GameTime.B == nil then settings.GameTime.B = string.format("%.3f", tB); end
	if settings.GameTime.X == nil then settings.GameTime.X = string.format("%.0f", screenWidth - 60); end
	if settings.GameTime.H == nil then settings.GameTime.H = true; end -- True = Show clock in 24h format
	ShowGameTime = settings.GameTime.V;
	GTbcAlpha = tonumber(settings.GameTime.A);
	GTbcRed = tonumber(settings.GameTime.R);
	GTbcGreen = tonumber(settings.GameTime.G);
	GTbcBlue = tonumber(settings.GameTime.B);
	_G.Clock24h = settings.GameTime.H;
	_G.GTLocX = tonumber(settings.GameTime.X);

	if GLocale == "de" then Turbine.PluginData.Save( Turbine.DataScope.Character, "TitanBarSettingsDE", settings ); end
	if GLocale == "en" then Turbine.PluginData.Save( Turbine.DataScope.Character, "TitanBarSettingsEN", settings ); end
	if GLocale == "fr" then Turbine.PluginData.Save( Turbine.DataScope.Character, "TitanBarSettingsFR", settings ); end
end
-- **^

-- **v Save settings v**
function SaveSettings()
	settings = {};
	--settings.Version = Version;

	settings.TitanBar = {};
	settings.TitanBar.A = string.format("%.3f", bcAlpha);
	settings.TitanBar.R = string.format("%.3f", bcRed);
	settings.TitanBar.G = string.format("%.3f", bcGreen);
	settings.TitanBar.B = string.format("%.3f", bcBlue);
	settings.TitanBar.L = TBLocale;
	
	settings.Money = {};
	settings.Money.V = ShowMoney;
	settings.Money.A = string.format("%.3f", MIbcAlpha);
	settings.Money.R = string.format("%.3f", MIbcRed);
	settings.Money.G = string.format("%.3f", MIbcGreen);
	settings.Money.B = string.format("%.3f", MIbcBlue);
	settings.Money.X = string.format("%.0f", _G.MILocX);
	settings.Money.S = _G.STM; --Show Total Money of all character on TitanBar Money control.

	settings.DestinyPoints = {};
	settings.DestinyPoints.V = ShowDestinyPoints;
	settings.DestinyPoints.A = string.format("%.3f", DPbcAlpha);
	settings.DestinyPoints.R = string.format("%.3f", DPbcRed);
	settings.DestinyPoints.G = string.format("%.3f", DPbcGreen);
	settings.DestinyPoints.B = string.format("%.3f", DPbcBlue);
	settings.DestinyPoints.X = string.format("%.0f", _G.DPLocX);

	settings.Shards = {};
	settings.Shards.V = ShowShards;
	settings.Shards.A = string.format("%.3f", SPbcAlpha);
	settings.Shards.R = string.format("%.3f", SPbcRed);
	settings.Shards.G = string.format("%.3f", SPbcGreen);
	settings.Shards.B = string.format("%.3f", SPbcBlue);
	settings.Shards.X = string.format("%.0f", _G.SPLocX);

	settings.SkirmishMarks = {};
	settings.SkirmishMarks.V = ShowSkirmishMarks;
	settings.SkirmishMarks.A = string.format("%.3f", SMbcAlpha);
	settings.SkirmishMarks.R = string.format("%.3f", SMbcRed);
	settings.SkirmishMarks.G = string.format("%.3f", SMbcGreen);
	settings.SkirmishMarks.B = string.format("%.3f", SMbcBlue);
	settings.SkirmishMarks.X = string.format("%.0f", _G.SMLocX);

	settings.Medallions = {};
	settings.Medallions.V = ShowMedallions;
	settings.Medallions.A = string.format("%.3f", MPbcAlpha);
	settings.Medallions.R = string.format("%.3f", MPbcRed);
	settings.Medallions.G = string.format("%.3f", MPbcGreen);
	settings.Medallions.B = string.format("%.3f", MPbcBlue);
	settings.Medallions.X = string.format("%.0f", _G.MPLocX);

	settings.Seals = {};
	settings.Seals.V = ShowSeals;
	settings.Seals.A = string.format("%.3f", SLbcAlpha);
	settings.Seals.R = string.format("%.3f", SLbcRed);
	settings.Seals.G = string.format("%.3f", SLbcGreen);
	settings.Seals.B = string.format("%.3f", SLbcBlue);
	settings.Seals.X = string.format("%.0f", _G.SLLocX);

	settings.Commodations = {};
	settings.Commodations.V = ShowCommodations;
	settings.Commodations.A = string.format("%.3f", CPbcAlpha);
	settings.Commodations.R = string.format("%.3f", CPbcRed);
	settings.Commodations.G = string.format("%.3f", CPbcGreen);
	settings.Commodations.B = string.format("%.3f", CPbcBlue);
	settings.Commodations.X = string.format("%.0f", _G.CPLocX);

	settings.BagInfos = {};
	settings.BagInfos.V = ShowBagInfos;
	settings.BagInfos.A = string.format("%.3f", BIbcAlpha);
	settings.BagInfos.R = string.format("%.3f", BIbcRed);
	settings.BagInfos.G = string.format("%.3f", BIbcGreen);
	settings.BagInfos.B = string.format("%.3f", BIbcBlue);
	settings.BagInfos.X = string.format("%.0f", _G.BILocX);

	settings.PlayerInfos = {};
	settings.PlayerInfos.V = ShowPlayerInfos;
	settings.PlayerInfos.A = string.format("%.3f", PIbcAlpha);
	settings.PlayerInfos.R = string.format("%.3f", PIbcRed);
	settings.PlayerInfos.G = string.format("%.3f", PIbcGreen);
	settings.PlayerInfos.B = string.format("%.3f", PIbcBlue);
	settings.PlayerInfos.X = string.format("%.0f", _G.PILocX);

	settings.EquipInfos = {};
	settings.EquipInfos.V = ShowEquipInfos;
	settings.EquipInfos.A = string.format("%.3f", EIbcAlpha);
	settings.EquipInfos.R = string.format("%.3f", EIbcRed);
	settings.EquipInfos.G = string.format("%.3f", EIbcGreen);
	settings.EquipInfos.B = string.format("%.3f", EIbcBlue);
	settings.EquipInfos.X = string.format("%.0f", _G.EILocX);
	
	settings.DurabilityInfos = {};
	settings.DurabilityInfos.V = ShowDurabilityInfos;
	settings.DurabilityInfos.A = string.format("%.3f", DIbcAlpha);
	settings.DurabilityInfos.R = string.format("%.3f", DIbcRed);
	settings.DurabilityInfos.G = string.format("%.3f", DIbcGreen);
	settings.DurabilityInfos.B = string.format("%.3f", DIbcBlue);
	settings.DurabilityInfos.X = string.format("%.0f", _G.DILocX);

	settings.PlayerLoc = {};
	settings.PlayerLoc.V = ShowPlayerLoc;
	settings.PlayerLoc.A = string.format("%.3f", PLbcAlpha);
	settings.PlayerLoc.R = string.format("%.3f", PLbcRed);
	settings.PlayerLoc.G = string.format("%.3f", PLbcGreen);
	settings.PlayerLoc.B = string.format("%.3f", PLbcBlue);
	settings.PlayerLoc.X = string.format("%.0f", _G.PLLocX);

	settings.GameTime = {};
	settings.GameTime.V = ShowGameTime;
	settings.GameTime.A = string.format("%.3f", GTbcAlpha);
	settings.GameTime.R = string.format("%.3f", GTbcRed);
	settings.GameTime.G = string.format("%.3f", GTbcGreen);
	settings.GameTime.B = string.format("%.3f", GTbcBlue);
	settings.GameTime.X = string.format("%.0f", _G.GTLocX);
	settings.GameTime.H = _G.Clock24h;

	if GLocale == "de" then Turbine.PluginData.Save( Turbine.DataScope.Character, "TitanBarSettingsDE", settings ); end
	if GLocale == "en" then Turbine.PluginData.Save( Turbine.DataScope.Character, "TitanBarSettingsEN", settings ); end
	if GLocale == "fr" then Turbine.PluginData.Save( Turbine.DataScope.Character, "TitanBarSettingsFR", settings ); end
end
-- **^
-- **v Reset All Settings v**
function ResetSettings()
	write( L["TBR"] );
	TBLocale = "en";
	ShowMoney, ShowDestinyPoints, ShowShards, ShowSkirmishMarks, ShowMedallions, ShowSeals, ShowCommodations, ShowBagInfos, ShowPlayerInfos, ShowEquipInfos,
	ShowDurabilityInfos, ShowPlayerLoc, ShowGameTime = true, false, false, false, false, false, false, true, true, true, true, true, true;
	_G.STM = false;

	if GLocale == "en" then tA, tR, tG, tB, tX = 0.3, 0.3, 0.3, 0.3, 0;
	else tA, tR, tG, tB, tX = "0,3", "0,3", "0,3", "0,3", "0"; end

	bcAlpha, bcRed, bcGreen, bcBlue = tA, tR, tG, tB; --Backcolor & default X Location for TitanBar
	MIbcAlpha, MIbcRed, MIbcGreen, MIbcBlue, _G.MILocX = tA, tR, tG, tB, 400; --for Money Control
	DPbcAlpha, DPbcRed, DPbcGreen, DPbcBlue, _G.DPLocX = tA, tR, tG, tB, tX; --for Destiny points Control
	SPbcAlpha, SPbcRed, SPbcGreen, SPbcBlue, _G.SPLocX = tA, tR, tG, tB, tX; --for Shards Control
	SMbcAlpha, SMbcRed, SMbcGreen, SMbcBlue, _G.SMLocX = tA, tR, tG, tB, tX; --for Skirmish marks Control
	MPbcAlpha, MPbcRed, MPbcGreen, MPbcBlue, _G.MPLocX = tA, tR, tG, tB, tX; --for Medallions Control
	CPbcAlpha, CPbcRed, CPbcGreen, CPbcBlue, _G.CPLocX = tA, tR, tG, tB, tX; --for Commodations Control
	SLbcAlpha, SLbcRed, SLbcGreen, SLbcBlue, _G.SLLocX = tA, tR, tG, tB, tX; --for Seal Control
	BIbcAlpha, BIbcRed, BIbcGreen, BIbcBlue, _G.BILocX = tA, tR, tG, tB, tX; --for bag Control
	EIbcAlpha, EIbcRed, EIbcGreen, EIbcBlue, _G.EILocX = tA, tR, tG, tB, 68; --for Equipement infos Control
	DIbcAlpha, DIbcRed, DIbcGreen, DIbcBlue, _G.DILocX = tA, tR, tG, tB, 138; --for Durability infos Control
	PIbcAlpha, PIbcRed, PIbcGreen, PIbcBlue, _G.PILocX = tA, tR, tG, tB, 206; --for Player infos Control
	
	GTbcAlpha, GTbcRed, GTbcGreen, GTbcBlue, _G.GTLocX = tA, tR, tG, tB, screenWidth - 60 --for Game time Control
	PLbcAlpha, PLbcRed, PLbcGreen, PLbcBlue, _G.PLLocX = tA, tR, tG, tB, screenWidth - 205; --r Location Control
	_G.Clock24h = true;

	SaveSettings();
	ReloadTitanBar();
end
-- **^